#include <bits/stdc++.h>

using namespace std;

long long int k,e,u,t,n,m;

int gcd(int a,int b)
{
    if (b==0)
        return a;
    return gcd(b,a%b);

}

int main()
{
    cin>>t;
    for(int i=0;i<t;i++){
        cin>>n>>m;
        long long int a[n];
        long long int b[m];
        cin>>a[0]>>a[1];
        u=abs(a[0]-a[1]);
        e=a[0]%u;
        if(a[1]%u!=e){
                u=gcd(abs(a[1]%u-e),u);
                e=a[1]%u;
        }
        for(int p=2;p<n;p++){
            cin>>a[p];
            if(a[p]%u!=e){
                u=gcd(abs(a[p]%u-e),u);
                e=a[p]%u;
            }
        }
        k=0;
        for(int j=0;j<m;j++){
            cin>>b[j];
            if(b[j]%u==e){
                k++;
            }
        }
        if(k==0){
            cout<<1<<endl;
        }
        else{
            cout<<0<<endl;
        }
    }
    return 0;
}